using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using WebChat.Models;

namespace WebChat.DAL
{
    public class MessageService
    {
        //¼
        public static bool AddMessage(Message message)
        {
            string sql =
                "INSERT message (FromUserId,ToUserId,Message,RecordTime,MessageState)" +
                "VALUES (@FromUserId, @ToUserId, @Message, @RecordTime, @MessageState)";

            sql += " ; SELECT @@IDENTITY";

            try
            {
                SqlParameter[] para = new SqlParameter[]
                {
                    new SqlParameter("@FromUserId", message.FromUser.Id), 
                    new SqlParameter("@ToUserId", message.ToUserId), 
                    new SqlParameter("@Message", message.MessageContent),
                    new SqlParameter("@RecordTime", message.RecordTime),
                    new SqlParameter("@MessageState",message.MessageState)
                };

                int newId = DBHelper.GetScalar(sql, para);
                if (newId > 0)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                return false;
            }
        }

        //õ¼
        public static IList<Message> GetTopMessages(int messageState,User user)
        {
            string sql = "";
            if (user == null)
            {
                sql = "select * from message where id in  (SELECT top 10 id FROM message where messageState='" + messageState + "' order by recordtime desc)  order by id asc";
            }
            else
            {
                sql = "select * from message where id in  (SELECT top 8 id FROM message where (messageState='" + messageState + "' and fromuserid='" + user.Id + "') or (messageState='" + messageState + "' and touserid='" + user.Id + "') order by recordtime desc)  order by id asc";
            }
            return GetMessagesBySql(sql);
        }

        
       //ϢidõϢ
        public static Message GetMessagesById(int id)
        {
            string sql = "SELECT * FROM message where id ='" + id + "'";
            IList<Message> messages = GetMessagesBySql(sql);
            return messages[0];
        }

        //sqlõϢ
        private static IList<Message> GetMessagesBySql(string safeSql)
        {
            List<Message> list = new List<Message>();

            try
            {
                DataTable table = DBHelper.GetDataSet(safeSql);

                foreach (DataRow row in table.Rows)
                {
                    Message message = new Message();
                    message.Id = (int)row["Id"];
                    message.ToUserId = (int)row["ToUserId"];
                    message.MessageContent = (string)row["Message"];
                    message.RecordTime = (DateTime)row["RecordTime"];
                    message.MessageState = (int)row["messagestate"];
                    message.FromUser = UserService.GetUserById((int)row["fromuserid"]);
                    list.Add(message);
                }
                return list;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                return null;
            }
        }

    }
}
