﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AjaxControlToolkit;
using WebChat.BLL;
using WebChat.Models;

public partial class Chat_ChatMain : System.Web.UI.Page
{     
    protected void Page_Load(object sender, EventArgs e)
    {
         lblTotalOnLine.Text = Application["user_session"].ToString();   
        DisplayChatUsers(); //显示聊天用户
        if (!Page.IsPostBack)
        {         
            DisplayMessageInfo();//显示聊天记录            
        }
    }


    protected void DisplayChatUsers()
    {
        //得到所有好友类型      
        IList<FriendsType> friendsTypes = FriendsTypeManager.GetFriendsType();

        //循环将好友类型添加到Accordion控件的标题中
        foreach (FriendsType item in friendsTypes)
        {
            AccordionPane ap = new AccordionPane(); //实例化一个AccordionPane 控件
            Label lblParentMenu = new Label();
            lblParentMenu.Text = item.TypeName;//指定标签的Text属性为好友类型名
            ap.HeaderContainer.Controls.Add(lblParentMenu); //将标签控件添加到AccordionPane标题部分
            int friendType = item.Id; //得到好友类型ID
            User user = (User)Session["CurrentUser"];
            IList<UserFriend> ufriends = FriendsTypeManager.GetUserFriends(user, friendType);//根据好友类型ID查找该对应的所用户
            foreach (UserFriend item2 in ufriends)
            {

                HtmlGenericControl hgc = new HtmlGenericControl("div");
                hgc.Style.Add("height", "50px");
                Image imgHead = new Image();
                if (item2.FriendUser.Gender == 1)
                {
                    imgHead.ImageUrl = "~/images/boy.gif";
                }
                else
                {
                    imgHead.ImageUrl = "~/images/girl.gif";
                }

                Label lblChildMenu = new Label(); //实例化一个标签控件用来显示子菜单                
                lblChildMenu.Text = item2.FriendUser.Name + "<br/>";//指定Text属性为用户名
                hgc.Controls.Add(imgHead);
                hgc.Controls.Add(lblChildMenu);

                hgc.Attributes.Add("onclick", "SelectUser('" + item2.FriendUser.Name + "')");

                ap.ContentContainer.Controls.Add(hgc);//将子菜单标签添加到AccordionPane内容部分 
            }
            Accordion1.Panes.Add(ap);//将AccordionPane追加到Accordion的Panes集合中            
        }
    }

    protected void DisplayMessageInfo()
    {
        dlPublicMessage.DataSource = obdsPublicMessage;//显示公共消息
        dlPublicMessage.DataBind();
       User user = (User)Session["CurrentUser"];
        dlSecretMessage.DataSource = MessageManager.GetSecretMessages(user);//显示私聊信息
        dlSecretMessage.DataBind();
    }

  
    protected void dlPublicMessage_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            int id = (int)dlPublicMessage.DataKeys[e.Item.ItemIndex];
            Message message = MessageManager.GetMessagesById(id);//根据消息id获得消息
            User fromUser = message.FromUser;
            int toUserId = message.ToUserId;
            User toUser = UserManager.GetUserById(toUserId);
            Label lblMessageContent = (Label)e.Item.FindControl("lblMessage");
            lblMessageContent.Text = "<font color='blue'>" + fromUser.Name + "</font>" + " 对 " + "<font color='green'>" + toUser.Name + "</font>" + " 说：" + message.MessageContent;
        }
    }
    protected void dlSecretMessage_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            int id = (int)dlSecretMessage.DataKeys[e.Item.ItemIndex];
            Message message = MessageManager.GetMessagesById(id);
            User fromUser = message.FromUser;
            int toUserId = message.ToUserId;
            User toUser = UserManager.GetUserById(toUserId);
            Label lblMessageContent = (Label)e.Item.FindControl("lblMessage");
            lblMessageContent.Text = "<font color='blue'>" + fromUser.Name + "</font>" + " 对 " + "<font color='green'>" + toUser.Name + "</font>" + " 悄悄地说：" + message.MessageContent;
        }
    }
    protected void cbIfSecret_CheckedChanged(object sender, EventArgs e)
    {
        //如果选择私聊
        if (cbIfSecret.Checked)
        {
            divSecret.Visible = true;
        }
        else
        {
            divSecret.Visible = false;
        }
    }
    protected void btnSure_Click(object sender, EventArgs e)
    {       
        Message message = new Message();
        message.FromUser = (User)Session["CurrentUser"];
        string toUserName = txtToUser.Text.Trim();
        message.ToUserId = UserManager.GetUserByName(toUserName).Id;
        message.MessageContent = txtMessageContent.Text;
        message.RecordTime = DateTime.Now;
        if (cbIfSecret.Checked)
        {
            message.MessageState = 1;
        }
        else
        {
            message.MessageState = 2;
        }
        MessageManager.AddMessage(message);//添加聊天记录
        txtToUser.Text = "";
        txtMessageContent.Text = "";
    }
    protected void Timer1_Tick(object sender, EventArgs e)
    {
        DisplayMessageInfo();//显示聊天记录
    }
    protected void btnLeave_ServerClick(object sender, EventArgs e)
    {
        //离线
        Session["CurrentUser"] = null;
        Session.Clear();
        Response.Redirect("~/Index.aspx");
    }
}
