﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AjaxControlToolkit;
using WebChat.BLL;
using WebChat.Models;

public partial class Chat : System.Web.UI.MasterPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        DisplayMenu(); //显示系统菜单
    }

    protected void DisplayMenu()
    {
        //得到所有父级菜单      
        IList<SysFun> sFun = SysFunManager.GetParentNodes();

        //循环将父级菜单添加到Accordion控件的标题中
        foreach (SysFun item in sFun)
        {
            AccordionPane ap = new AccordionPane(); //实例化一个AccordionPane 控件
            Label lblParentMenu = new Label();
            lblParentMenu.Text = item.DisplayName;//指定标签的Text属性为父菜单名
            ap.HeaderContainer.Controls.Add(lblParentMenu); //将标签控件添加到AccordionPane标题部分
            int nodeId = item.NodeId; //得到父菜单ID
            IList<SysFun> cFun = SysFunManager.GetChildNodes(nodeId);//根据父菜单ID查找该对应的所有子菜单

            foreach (SysFun item2 in cFun)
            {
                Label lblChildMenu = new Label(); //实例化一个标签控件用来显示子菜单
                string url = ResolveUrl(item2.URL);
                lblChildMenu.Text = "<a  href=" + url + ">" + item2.DisplayName + "</a><br/>";//指定Text属性为子菜单名
                ap.ContentContainer.Controls.Add(lblChildMenu);//将子菜单标签添加到AccordionPane内容部分 
            }
            Accordion1.Panes.Add(ap);//将AccordionPane追加到Accordion的Panes集合中            
        }
    }
}
