using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using WebChat.Models;

namespace WebChat.DAL
{
    public class FriendsTypeService
    {
        public static IList<FriendsType> GetAllFriendsTypes()
        {
            string sql = "select * from FriendsTypeInfo order by id";
            return GetFriendsTypeBySql(sql);
        }

        public static IList<UserFriend> GetUserFriends(User user,int friendType)
        {
            string sql = "select * from userfriends where friendtype='" + friendType + "' and userid='"+user.Id+"' order by id";
            return GetUserFriendsBySql(sql);
        }

        private static IList<FriendsType> GetFriendsTypeBySql(string safeSql)
        {
            List<FriendsType> list = new List<FriendsType>();

            try
            {
                DataTable table = DBHelper.GetDataSet(safeSql);

                foreach (DataRow row in table.Rows)
                {
                    FriendsType ft = new FriendsType();
                    ft.Id = (int)row["Id"];
                    ft.TypeName = (string)row["typename"];
                    list.Add(ft);
                }

                return list;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }

        private static IList<UserFriend> GetUserFriendsBySql(string safeSql)
        {
            List<UserFriend> list = new List<UserFriend>();

            try
            {
                DataTable table = DBHelper.GetDataSet(safeSql);

                foreach (DataRow row in table.Rows)
                {
                    UserFriend uf = new UserFriend();
                    uf.Id = (int)row["Id"];
                    uf.User = UserService.GetUserById((int)row["UserId"]); //FK
                    uf.FriendUser = UserService.GetUserById((int)row["FriendUserId"]); //FK
                    uf.FriendsType = FriendsTypeService.GetFriendsTypeById((int)row["FriendType"]);//FK
                   
                    list.Add(uf);
                }
                return list;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }

        public static FriendsType GetFriendsTypeById(int id)
        {
            string sql = "SELECT * FROM friendstypeinfo WHERE Id = @Id";
            try
            {
                SqlDataReader reader = DBHelper.GetReader(sql, new SqlParameter("@Id", id));
                if (reader.Read())
                {
                    FriendsType ft = new FriendsType();
                    ft.Id = (int)reader["Id"];
                    ft.TypeName = (string)reader["TypeName"];               
                    reader.Close();
                    return ft;
                }
                else
                {
                    reader.Close();
                    return null;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                return null;
            }
        }

    }
}
